searchNodes=[{"doc":"Generates router and plug handlers for a proper OpenAPI Specification in YAML or JSON file. mix oas . gen . plug -- file path / to / openapi . yaml mix oas . gen . plug -- file path / to / openapi . yml mix oas . gen . plug -- file path / to / openapi . json The arguments of oas.gen.plug mix task: --file , required, the completed path to the specification file in YAML or JSON format. --router , optional, the generated router's module alias, by default it is Router (the full module name is Oasis.Gen.Router by default), for example we set --router Hello.MyRouter meanwhile there is no other special name space defined, the final router module is Oasis.Gen.Hello.MyRouter in /lib/oasis/gen/hello/my_router.ex path. --name-space , optional, the generated all modules' name space, by default it is Oasis.Gen , this argument will always override the name space from the input --file if any &quot;x-oasis-name-space&quot; field(s) defined. --force , optional, forces creation without a shell prompt. --quiet , optional, does not log command output.","ref":"Mix.Tasks.Oas.Gen.Plug.html","title":"Mix.Tasks.Oas.Gen.Plug","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Oas.Gen.Plug.html#run/1","title":"Mix.Tasks.Oas.Gen.Plug.run/1","type":"function"},{"doc":"Base on Plug.Builder , this module can be use -d into a module in order to build a plug pipeline: defmodule MyApp.HelloController do use Oasis.Controller plug ( Plug.Parsers , parsers : [ :urlencoded ] , pass : [ &quot;*/*&quot; ] ) def call ( conn , opts ) do conn = super ( conn , opts ) json ( conn , %{ &quot;body_params&quot; =&gt; conn . body_params } ) end end And provide some common functionality for easily use, this realization comes from Phoenix.Controller .","ref":"Oasis.Controller.html","title":"Oasis.Controller","type":"module"},{"doc":"Sends html response. Examples iex&gt; html ( conn , &quot;&lt;html&gt;...&lt;/html&gt;&quot; )","ref":"Oasis.Controller.html#html/2","title":"Oasis.Controller.html/2","type":"function"},{"doc":"Sends JSON response. It uses Jason to encode the input as an iodata data. Examples iex&gt; json ( conn , %{ id : 1 } )","ref":"Oasis.Controller.html#json/2","title":"Oasis.Controller.json/2","type":"function"},{"doc":"Returns the router module as an atom, raises if unavailable.","ref":"Oasis.Controller.html#router_module/1","title":"Oasis.Controller.router_module/1","type":"function"},{"doc":"Sends text response. Examples iex&gt; text ( conn , &quot;hello&quot; ) iex&gt; text ( conn , :implements_to_string )","ref":"Oasis.Controller.html#text/2","title":"Oasis.Controller.text/2","type":"function"},{"doc":"Callback There are two callback functions reserved for use in the generated modules when we use the hmac security scheme of the OpenAPI Specification. crypto_config/3 , provides a way to define the crypto-related key information for the high level usage, it required to return a Oasis.HMACToken.Crypto struct (or nil). verify/3 , an optional function to provide a way to custom the verification of the token, you may want to validate request datetime, HTTP body or other more rules to verify it. Example Here is an example to verify that HTTP request time does not exceed the current time by 1 minute. defmodule Oasis.Gen.HMACAuth do @behaviour Oasis.HMACToken alias Oasis.HMACToken.Crypto # in seconds @max_diff 60 @impl true def crypto_config ( _conn , _opts , _credential ) do % Crypto { credential : &quot;...&quot; , secret : &quot;...&quot; } end @impl true def verify ( conn , token , _opts ) do with { :ok , _ } &lt;- Oasis.HMACToken . verify ( conn , token , opts ) , { :ok , timestamp } &lt;- conn |&gt; get_header_date ( ) |&gt; parse_header_date ( ) do timestamp_now = DateTime . utc_now ( ) |&gt; DateTime . to_unix ( ) if abs ( timestamp_now - timestamp ) &lt; @max_diff do { :ok , timestamp } else { :error , :expired } end end end defp get_header_date ( conn ) do conn |&gt; Plug.Conn . get_req_header ( &quot;x-oasis-date&quot; ) |&gt; case do [ date ] -&gt; date _ -&gt; nil end end defp parse_header_date ( str ) when is_binary ( str ) do with { :ok , datetime } &lt;- Timex . parse ( str , &quot;%a, %d %b %Y %H:%M:%S GMT&quot; , :strftime ) , timestamp when is_integer ( timestamp ) &lt;- Timex . to_unix ( datetime ) do { :ok , timestamp } end end defp parse_header_date ( _otherwise ) , do : { :error , :expired } end","ref":"Oasis.HMACToken.html","title":"Oasis.HMACToken","type":"behaviour"},{"doc":"","ref":"Oasis.HMACToken.html#c:crypto_config/3","title":"Oasis.HMACToken.crypto_config/3","type":"callback"},{"doc":"Sign HTTP requests according to settings.","ref":"Oasis.HMACToken.html#sign/4","title":"Oasis.HMACToken.sign/4","type":"function"},{"doc":"Default implementation of the callback verify , only verify the signature.","ref":"Oasis.HMACToken.html#verify/3","title":"Oasis.HMACToken.verify/3","type":"function"},{"doc":"","ref":"Oasis.HMACToken.html#c:verify/3","title":"Oasis.HMACToken.verify/3","type":"callback"},{"doc":"","ref":"Oasis.HMACToken.html#t:opts/0","title":"Oasis.HMACToken.opts/0","type":"type"},{"doc":"","ref":"Oasis.HMACToken.html#t:token/0","title":"Oasis.HMACToken.token/0","type":"type"},{"doc":"","ref":"Oasis.HMACToken.html#t:verify_error/0","title":"Oasis.HMACToken.verify_error/0","type":"type"},{"doc":"In general, when we define a hmac security scheme of the OpenAPI Specification, the generated module will use this struct to define the required crypto-related key information.","ref":"Oasis.HMACToken.Crypto.html","title":"Oasis.HMACToken.Crypto","type":"module"},{"doc":"","ref":"Oasis.HMACToken.Crypto.html#t:t/0","title":"Oasis.HMACToken.Crypto.t/0","type":"type"},{"doc":"Base on Plug.Router to add a pre-parser to convert and validate the path param(s) in the final generated HTTP verb match functions. The generated router module uses Oasis.Router to instead of Plug.Router , in fact, they don't make a huge difference, except that specify parameters which will then be available and types coverted in the function body: get ( &quot;/hello/:id&quot; , private : %{ path_schema : %{ &quot;id&quot; =&gt; %{ &quot;schema&quot; =&gt; % ExJsonSchema.Schema.Root { schema : %{ &quot;type&quot; =&gt; &quot;integer&quot; } } } } } ) do # Notice that the `:id` variable is an integer send_resp ( conn , 200 , &quot;hello \#{ id } &quot; ) end The :id parameter will also be available and coverted as an integer in the function body as conn.params[&quot;id&quot;] and conn.path_params[&quot;id&quot;] .","ref":"Oasis.Router.html","title":"Oasis.Router","type":"module"},{"doc":"A simple wrapper of Plug.Crypto to provide a way to generate and verify bearer token for use in the bearer security scheme of the OpenAPI Specification. When we use sign/2 and verify/2 , the data stored in the token is signed to prevent tampering but not encrypted, in this scenario, we can store identification information (such as user NON-PII data), but SHOULD NOT be used to store confidential information (such as credit card numbers, PIN code). &quot;NON-PII&quot; means Non Personally Identifiable Information. If you don't want clients to be able to determine the value of the token, you may use encrypt/2 and decrypt/2 to generate and verify the token. Callback There are two callback functions reserved for use in the generated modules when we use the bearer security scheme of the OpenAPI Specification. crypto_config/2 , provides a way to define the crypto-related key information for the high level usage, it required to return an Oasis.Token.Crypto struct. verify/3 , an optional function to provide a way to custom the verification of the token, you may want to use encrypt/decrypt to the token, or other more rules to verify it.","ref":"Oasis.Token.html","title":"Oasis.Token","type":"behaviour"},{"doc":"Avoid using the application enviroment as the configuration mechanism for this library, and make crypto-related key information configurable when use bearer authentication. The Oasis.Plug.BearerAuth module invokes this callback function to fetch a predefined Oasis.Token.Crypto struct, and then use it to verify the bearer token of the request.","ref":"Oasis.Token.html#c:crypto_config/2","title":"Oasis.Token.crypto_config/2","type":"callback"},{"doc":"A wrapper of Plug.Crypto.decrypt/4 to use Oasis.Token.Crypto to decrypt the original data from the token and verify its integrity, please see Plug.Crypto.decrypt/4 for details.","ref":"Oasis.Token.html#decrypt/2","title":"Oasis.Token.decrypt/2","type":"function"},{"doc":"A wrapper of Plug.Crypto.encrypt/4 to use Oasis.Token.Crypto to encode, encrypt and sign data into a token you can send to clients, please see Plug.Crypto.encrypt/4 for details.","ref":"Oasis.Token.html#encrypt/2","title":"Oasis.Token.encrypt/2","type":"function"},{"doc":"Generates a random string in N length via :crypto.strong_rand_bytes/1 .","ref":"Oasis.Token.html#random_string/1","title":"Oasis.Token.random_string/1","type":"function"},{"doc":"A wrapper of Plug.Crypto.sign/4 to use Oasis.Token.Crypto to sign data into a token you can send to clients, please see Plug.Crypto.sign/4 for details.","ref":"Oasis.Token.html#sign/2","title":"Oasis.Token.sign/2","type":"function"},{"doc":"A wrapper of Plug.Crypto.verify/4 to use Oasis.Token.Crypto to decode the original data from the token and verify its integrity, please see Plug.Crypto.verify/4 for details.","ref":"Oasis.Token.html#verify/2","title":"Oasis.Token.verify/2","type":"function"},{"doc":"An optional callback function to decode the original data from the token, and verify its integrity. If we use sign/2 to create a token, sign it, then provide it to a client application, the client will then use this token to authenticate requests for resources from the server, in this scenario, as a common use case, the Oasis.Plug.BearerAuth module uses verify/2 to finish the verification of the bearer token, so we do not need to implement this callback function in general. But if we use encrypt/2 or other encryption methods to encode, encrypt, and sign data into a token and send to clients, we need to implement this callback function to custom the way to decrypt the token and verify its integrity.","ref":"Oasis.Token.html#c:verify/3","title":"Oasis.Token.verify/3","type":"callback"},{"doc":"","ref":"Oasis.Token.html#t:opts/0","title":"Oasis.Token.opts/0","type":"type"},{"doc":"","ref":"Oasis.Token.html#t:verify_error/0","title":"Oasis.Token.verify_error/0","type":"type"},{"doc":"A module to represent crypto-related key information. All fields of Oasis.Token.Crypto are completely map to: Plug.Crypto.encrypt/4 and Plug.Crypto.decrypt/4 Plug.Crypto.sign/4 and Plug.Crypto.verify/4 Please refer the above functions for details to construct it. In general, when we define a bearer security scheme of the OpenAPI Specification, the generated module will use this struct to define the required crypto-related key information. Please note that the value of the :secret_key_base field is required to be a string at least 20 length.","ref":"Oasis.Token.Crypto.html","title":"Oasis.Token.Crypto","type":"module"},{"doc":"","ref":"Oasis.Token.Crypto.html#t:t/0","title":"Oasis.Token.Crypto.t/0","type":"type"},{"doc":"Functionality for providing Bearer HTTP authentication. It is recommended to only use this module in production if SSL is enabled and enforced. Example As any other Plug, we can use the bearer_auth/2 plug: # lib/pre_handler.ex import Oasis.Plug.BearerAuth plug :bearer_auth , security : Oasis.Gen.BearerAuth key_to_assigns : :user_id # lib/oasis/gen/bearer_auth.ex defmodule Oasis.Gen.BearerAuth do @behaviour Oasis.Token @impl true def crypto_config ( _conn , _options ) do # return a `Oasis.Token.Crypto` struct in your preferred way % Oasis.Token.Crypto { secret_key_base : &quot;...&quot; , salt : &quot;...&quot; , max_age : 7200 } end end Or directly plug Oasis.Plug.BearerAuth : # lib/pre_handler.ex plug ( Oasis.Plug.BearerAuth , security : Oasis.Gen.BearerAuth , key_to_assigns : :user_id ) # lib/oasis/gen/bearer_auth.ex defmodule Oasis.Gen.BearerAuth do @behaviour Oasis.Token @impl true def crypto_config ( _conn , _options ) do # ... end end We define the bearer security scheme of the OpenAPI specification in our API design document, and then generate the related module and provide the requried configuration, let's take some examples from YAML specifications. Here we apply a global security to all operation objects: openapi : 3.1 . 0 components : securitySchemes : bearerAuth : # arbitrary name for the security scheme type : http scheme : bearer bearerFormat : JWT security : - bearerAuth : [ ] Here we apply a security to a operation object, and define an optional specification extension &quot;x-oasis-key-to-assigns&quot; field to the :key_to_assigns option of bearer_auth/2 : openapi : 3.1 . 0 components : securitySchemes : bearerAuth : # arbitrary name for the security scheme type : http scheme : bearer bearerFormat : JWT x - oasis - key - to - assigns : user_id paths : / something : get : security : - bearerAuth : [ ] The above arbitrary name &quot;bearerAuth&quot; for the security scheme will be transferred into a generated module (see the above mentioned &quot;Oasis.Gen.BearerAuth&quot; module) to provide the required crypto-related configuration, and use it as the value to the :security option of bearer_auth/2 . By default, the generated &quot;BearerAuth&quot; module will inherit the module name space in order from the paths object, and then the operation object if they defined the &quot;x-oasis-name-space&quot; field, or defaults to Oasis.Gen if there are no any specification defined. As an option, we can add an &quot;x-oasis-name-space&quot; field as a specification extension of the security scheme object to override the module name space, meanwhile, the optional --name-space argument to the mix oas.gen.plug command line is in the highest priority to set the name space of the generated modules. components : securitySchemes : bearerAuth : # arbitrary name for the security scheme type : http scheme : bearer bearerFormat : JWT x - oasis - key - to - assigns : user_id x - oasis - name - space : MyAuth In the above example, the final generated module name of &quot;bearerAuth&quot; is MyAuth.BearerAuth when there is no --name-space argument of mix task input. After we define the bearer authentication into the specification, then run mix oas.gen.plug task with this spec file (via --file argument), there will generate the above similar code to the related module file as long as it does not exist, it also follows the name space definition of that module, and the generation does not override it once the file existed, we need to further edit this file to provide a crypto-related configuration in your preferred way. If we need a customization to verify the bearer token, we can implement a callback function Oasis.Token.verify/3 to this scenario. # lib/bearer_auth.ex defmodule BearerAuth do @behaviour Oasis.Token @impl true def crypto_config ( conn , options ) do % Oasis.Token.Crypto { ... } end @impl true def verify ( conn , token , options ) do # write your rules to verify the token, # and return the expected results in: # {:ok, data}, verified # {:error, :expired}, expired token # {:error, :invalid}, invalid token end end","ref":"Oasis.Plug.BearerAuth.html","title":"Oasis.Plug.BearerAuth","type":"module"},{"doc":"High-level usage of Baerer HTTP authentication. See the module docs for examples. Options :security , required, a module be with Oasis.Token behaviour. :key_to_assigns , optional, after the verification of the token, the original data will be stored into the conn.assigns once this option defined, for example, if set it as :user_id , we can access the verified data via conn.assigns.user_id in the next plug pipeline.","ref":"Oasis.Plug.BearerAuth.html#bearer_auth/2","title":"Oasis.Plug.BearerAuth.bearer_auth/2","type":"function"},{"doc":"Parses the request token from Bearer HTTP authentication. It returns either {:ok, token} or {:error, &quot;invalid_request&quot;} .","ref":"Oasis.Plug.BearerAuth.html#parse_bearer_auth/1","title":"Oasis.Plug.BearerAuth.parse_bearer_auth/1","type":"function"},{"doc":"Requests bearer authentication from the client. It sets the response to status 401 with &quot;Unauthorized&quot; as body. The response is not sent though (nor the connection is halted), allowing developers to further customize it. A response example: HTTP / 1.1 401 Unauthorized www - authenticate : Bearer realm = &quot;Application&quot; , error = &quot;invalid_token&quot; , error_description = &quot;the access token expired&quot; Options :realm - the authentication realm. The value is not fully sanitized, so do not accept user input as the realm and use strings with only alphanumeric characters and space. :error - an optional tuple to represent &quot;error&quot; and &quot;error_description&quot; attributes, for example, {&quot;invalid_token&quot;, &quot;the access token expired&quot;}","ref":"Oasis.Plug.BearerAuth.html#request_bearer_auth/2","title":"Oasis.Plug.BearerAuth.request_bearer_auth/2","type":"function"},{"doc":"Functionality for providing an HMAC HTTP authentication. STATEMENT : Currently there is no standard HMAC authentication definition in the OpenAPI v3.1.0 specification, we implement this function to add an hmac-&lt;algorithm&gt; as the corresponding scheme field to http type of the security scheme, thanks for some public HMAC services or API design as references: Azure REST API Authentication HMAC AWS S3 sigv4 Authentication AWS general sigv4 Authentication example It is recommended to only use this module in production if SSL is enabled and enforced. Usage As any other Plug, we can use the hmac_auth/2 plug: # lib/pre_handler.ex import Oasis.Plug.HMACAuth plug ( :hmac_auth , signed_headers : &quot;x-oasis-date;host&quot; , algorithm : :sha256 , security : Oasis.Gen.HMACAuth ) # lib/oasis/gen/hmac_auth.ex defmodule Oasis.Gen.HMACAuth do @behaviour Oasis.HMACToken @impl true def crypto_config ( _conn , _options , _credential ) do # return `Oasis.HMACToken.Crypto` struct in your preferred way % Oasis.HMACToken.Crypto { credential : &quot;client id&quot; , secret : &quot;hmac secret&quot; , } end end Or directly plug Oasis.Plug.HMACAuth : # lib/pre_handler.ex plug ( Oasis.Plug.HMACAuth , signed_headers : &quot;x-oasis-date;host&quot; , algorithm : :sha256 , security : Oasis.Gen.HMACAuth ) # lib/oasis/gen/HMAC_auth.ex defmodule Oasis.Gen.HMACAuth do @behaviour Oasis.HMACToken @impl true def crypto_config ( _conn , _options , _credential ) do ... end end Let's take an example from a YAML specification, we apply a global security to all operation objects: openapi: 3.1.0 components: securitySchemes: HMACAuth: # arbitrary name for the security scheme type: http scheme: hmac-sha256 x-oasis-signed-headers: x-oasis-date;host x-oasis-name-space: MyAuth security: - HMACAuth: [] The above arbitrary name &quot;HMACAuth&quot; for the security scheme will be transferred into a generated module (see the above mentioned &quot;Oasis.Gen.HMACAuth&quot; module) to provide the required crypto-related configuration, and use it as the value to the :security option of hmac_auth/2 . By default, the generated &quot;HMACAuth&quot; module will inherit the module name space in order from the paths object, and then the operation object if they defined an x-oasis-name-space field, or defaults to Oasis.Gen if there are no any specification defined. As an option, we can add an x-oasis-name-space field as a specification extension of the security scheme object to override the generated module's name space, meanwhile, the optional --name-space argument to the mix oas.gen.plug command line is in the highest priority to set the name space of the all generated modules. components: securitySchemes: HMACAuth: # arbitrary name for the security scheme type: http scheme: hmac-sha256 x-oasis-signed-headers: x-oasis-date;host x-oasis-name-space: MyAuth In the above example, the final generated module name of &quot;HMACAuth&quot; is &quot;MyAuth.HMACAuth&quot; when there is no --name-space argument of mix task input. After we define the HMAC authentication into the specification, then run mix oas.gen.plug task with this spec file (via --file argument), there will generate the above similar code to the related module file as long as it does not exist, it also follows the name space definition to that module, and the generation does not override it once the file existed, we need to further edit this file to provide a crypto-related configuration in your preferred way. If we need a customization to verify the HMAC token, we can implement a callback function Oasis.HMACToken.verify/3 to this scenario. # lib/hmac_auth.ex defmodule HMACAuth do @behaviour Oasis.HMACToken @impl true def crypto_config ( conn , options , credential ) do ... end @impl true def verify ( conn , token , options ) do # write your rules to verify the token, # and return the expected results in: # {:ok, token}, verified # {:error, :expired}, expired token # {:error, :invalid_token}, invalid token end end Supported Algorithms Here we use :crypto.mac/4 to compute a MAC of type :hmac from data, the completed supported algorithms can be found in the hash algorithm type of :crypto , see Erlang/OTP crypto user's guide - HMAC for more details.","ref":"Oasis.Plug.HMACAuth.html","title":"Oasis.Plug.HMACAuth","type":"module"},{"doc":"High-level usage of HMAC HTTP authentication. See the module docs for examples. Options :algorithm , required, see Algorithms Supported for details. :security , required, a module be with Oasis.HMACToken behaviour. :signed_headers , required, defines HTTP request headers added to the signature, the provided headers are required in the request, and both in client/server side will use them into signature in the explicit definition order. (e.g., &quot;x-oasis-date;host&quot; )","ref":"Oasis.Plug.HMACAuth.html#hmac_auth/2","title":"Oasis.Plug.HMACAuth.hmac_auth/2","type":"function"},{"doc":"Parses the request token from HMAC HTTP authentication.","ref":"Oasis.Plug.HMACAuth.html#parse_hmac_auth/2","title":"Oasis.Plug.HMACAuth.parse_hmac_auth/2","type":"function"},{"doc":"","ref":"Oasis.Plug.HMACAuth.html#t:algorithm/0","title":"Oasis.Plug.HMACAuth.algorithm/0","type":"type"},{"doc":"","ref":"Oasis.Plug.HMACAuth.html#t:opts/0","title":"Oasis.Plug.HMACAuth.opts/0","type":"type"},{"doc":"A plug to convert types and validate the HTTP request parameters by the schemas of the OpenAPI definition. The schema options can be found in the generated pre- plug handler file, the full list: :query_schema :header_schema :cookie_schema :body_schema All of these options are fully map and generated from the corresponding definition of the OpenAPI Specification. When the query parameters are verified by the validation of :query_schema , the coverted types of query parameters are reserved in :query_params and :params field of the Plug.Conn . When the header parameters are verified by the validation of :header_schema , the converted types of header parameters are reserved in :req_headers field of the Plug.Conn . When the cookie parameters are verified by the validation of :cookie_schema , the coverted types of cookie parameters are reserved in :req_cookies field of the Plug.Conn . When the request body is verified by the validation of :body_schema , the coverted types of request body are reserved in :body_params and :params field of the Plug.Conn .","ref":"Oasis.Plug.RequestValidator.html","title":"Oasis.Plug.RequestValidator","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Oasis.Plug.RequestValidator.html#call/2","title":"Oasis.Plug.RequestValidator.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Oasis.Plug.RequestValidator.html#init/1","title":"Oasis.Plug.RequestValidator.init/1","type":"function"},{"doc":"This error is used to indicate could not parse a parameter into the type due to client error.","ref":"Oasis.BadRequestError.Invalid.html","title":"Oasis.BadRequestError.Invalid","type":"module"},{"doc":"This error is used to indicate the provided token is expired, revoked, malformed, or invalid.","ref":"Oasis.BadRequestError.InvalidToken.html","title":"Oasis.BadRequestError.InvalidToken","type":"module"},{"doc":"This error is used to indicate could not pass the validation of the defined json schema. This module is an equivalent replacement to ExJsonSchema.Validator.Error , we could see more detailed information in the :error field be with &quot;ExJsonSchema.Validator.Error.*&quot; modules.","ref":"Oasis.BadRequestError.JsonSchemaValidationFailed.html","title":"Oasis.BadRequestError.JsonSchemaValidationFailed","type":"module"},{"doc":"This error is used to indicate there missing a required parameter due to client error.","ref":"Oasis.BadRequestError.Required.html","title":"Oasis.BadRequestError.Required","type":"module"},{"doc":"Error raised when some reason could not process the request due to client error.","ref":"Oasis.BadRequestError.html","title":"Oasis.BadRequestError","type":"exception"},{"doc":"Error raised when use an invalid file path to generate corresponding modules.","ref":"Oasis.FileNotFoundError.html","title":"Oasis.FileNotFoundError","type":"exception"},{"doc":"Error raised when use some invalid OpenAPI specification to generate corresponding modules.","ref":"Oasis.InvalidSpecError.html","title":"Oasis.InvalidSpecError","type":"exception"},{"doc":"","ref":"readme.html","title":"Oasis","type":"extras"},{"doc":"Background The OpenAPI Specification (OAS) defines a standard, programming language-agnostic interface description for REST APIs, which allows both humans and computers to discover and understand the capabilities of a service without requiring access to source code, additional documentation, or inspection of network traffic. When properly defined via OpenAPI, a consumer can understand and interact with the remote service with a minimal amount of implementation logic. Similar to what interface descriptions have done for lower-level programming, the OpenAPI Specification removes guesswork in calling a service. Oasis is: Base on Plug 's implements, according to the OpenAPI Specification to generate server's router and the all well defined HTTP request handlers, since the OAS defines a detailed collection of data types by JSON Schema Specification , Oasis leverages this and focuses on the types conversion and validation to the parameters of the HTTP request. Maintain an OpenAPI Specification document(in YAML or JSON) is the first priority Generate the maintainable router and HTTP request handlers code by the defined document In general, we do not need to manually write the OpenAPI definitions in Elixir Simplify the REST APIs to convert types and validate the parameters of the HTTP request More reference and communication to your REST APIs","ref":"readme.html#introduction","title":"Oasis - Introduction","type":"extras"},{"doc":"Add oasis as a dependency to your mix.exs def deps do [ { :oasis , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"Oasis - Installation","type":"extras"},{"doc":"Oasis does not cover the full OpenAPI specification, so far the implements contain: Components Object Paths Object Path Item Object Operation Object Parameter Object Request Body Object Media Type Object Header Object Reference Object Schema Object Security Scheme Object Bearer Authentication, please see Oasis.Plug.BearerAuth for details. HMAC Authentication, please see Oasis.Plug.HMACAuth for details. We also have some OpenAPI Specification Extensions defined for use, please see our Specification Extensions Guide .","ref":"readme.html#implements-to-oas","title":"Oasis - Implements to OAS","type":"extras"},{"doc":"Prepare YAML or JSON specification First, write your API document refer the OpenAPI Specification(see reference for details), we build Oasis with the version 3.1.0 of the OAS, as usual, the common use case should be covered for the version 3.0.* of the OAS. Here is a minimum specification for an example in YAML, we save it as &quot;petstore-mini.yaml&quot; in this tutorial. openapi: &quot;3.1.0&quot; info: title: Petstore Mini paths: /pets: get: parameters: - name: tags in: query required: false schema: type: array items: type: string - name: limit in: query requried: false schema: type: integer format: int32 response: '200': content: application/json: schema: type: array items: $ref: '#/components/schemas/Pet' post: operationId: addPet requestBody: required: true content: application/json: schema: $ref: '#/components/schemas/NewPet' response: '200': content: application/json: schema: $ref: '#/components/schemas/Pet' /pets/{id}: get: operationId: find pet by id parameters: - name: id in: path required: true schema: type: integer format: int64 response: '200': content: application/json: schema: $ref: '#/components/schemas/Pet' components: schemas: Pet: allOf: - $ref: '#/components/schemas/NewPet' - type: object required: - id properties: id: type: integer format: int64 NewPet: type: object required: - name properties: name: type: string tag: type: string Run mix task And then we run the following mix task to generate the corresponding files: mix oas . gen . plug -- file path / to / petstore - mini . yaml We will see these output: Generates Router and Plug modules from OAS * creating lib / oasis / gen / router . ex * creating lib / oasis / gen / pre_find_pet_by_id . ex * creating lib / oasis / gen / find_pet_by_id . ex * creating lib / oasis / gen / pre_add_pet . ex * creating lib / oasis / gen / add_pet . ex * creating lib / oasis / gen / pre_get_pets . ex * creating lib / oasis / gen / get_pets . ex The arguments of oas.gen.plug mix task: --file , required, the completed path to the specification file in YAML or JSON format. --router , optional, the generated router's module alias, by default it is Router (the full module name is Oasis.Gen.Router by default), for example we set --router Hello.MyRouter meanwhile there is no other special name space defined, the final router module is Oasis.Gen.Hello.MyRouter in /lib/oasis/gen/hello/my_router.ex path. --name-space , optional, the generated all modules' name space, by default it is Oasis.Gen , this argument will always override the name space from the input --file if any &quot;x-oasis-name-space&quot; field(s) defined. Special instructions Name Plug's handler Refer the OAS, the operationId field of Operation Object is not required, but it should be unique among all operations described in the API if operationId field exists. When use this field, Oasis will use it to construct the generated module alias and the file name of &quot;.ex&quot; file, e.g. see the above find_pet_by_id.ex file with Oasis.Gen.FindPetById module name. When not use this filed, Oasis will combine the HTTP verb with the URL to generate the module alias and the file name of &quot;.ex&quot; file, e.g. see the above get_pets.ex file with Oasis.Gen.GetPets module name. Generated code to folder The generated codes are always put in the lib directory of your application root path, because they need to be integrated into your application in runtime. Custom name space of generated modules By default, the name space of the generated module is Oasis.Gen and its folder path is lib/oasis/gen , but we can custom it use these ways: As a final global definition when run oas.gen.plug mix task, input --name-space argument to set this, this argument always overrides all name space even we have some sections of document have special definition (via &quot;x-oasis-name-space&quot; ), for example: mix oas . gen . plug -- file path / to / petstore - mini . yaml -- name - space My.Petstore Generates Router and Plug modules from OAS * creating lib / my / petstore / router . ex * creating lib / my / petstore / pre_find_pet_by_id . ex * creating lib / my / petstore / find_pet_by_id . ex * creating lib / my / petstore / pre_add_pet . ex * creating lib / my / petstore / add_pet . ex * creating lib / my / petstore / pre_get_pets . ex * creating lib / my / petstore / get_pets . ex Now, we can see the generation folder path is lib/my/petstore , let's open the get_pets.ex file, the module name changed from Oasis.Gen.GetPets to My.Petstore.GetPets . Use &quot;x-oasis-name-space&quot; in the OAS's Operation Object , for example, add this newline x-oasis-name-space: Common.Api as below: paths: /pets: get: x-oasis-name-space: Common.Api parameters: - name: tags ... post: ... /pets/{id}: ... Run again, please note this time no --name-space argument. mix oas . gen . plug -- file path / to / petstore - mini . yaml Generates Router and Plug modules from OAS * creating lib / oasis / gen / router . ex * creating lib / oasis / gen / pre_find_pet_by_id . ex * creating lib / oasis / gen / find_pet_by_id . ex * creating lib / oasis / gen / pre_add_pet . ex * creating lib / oasis / gen / add_pet . ex * creating lib / common / api / pre_get_pets . ex * creating lib / common / api / get_pets . ex We can see pre_get_pets.ex and get_pets.ex files are moved into the expected path, and their module names are Common.Api.GetPets and Common.Api.PreGetPets , other operations do not define any &quot;x-oasis-name-space&quot; field, so they still use the default one Oasis.Gen . Use &quot;x-oasis-name-space&quot; in the OAS's Paths Object , this use case as a global setting and can archive it in the document under the file version management, for example, add this newline x-oasis-name-space: Common.Api as below: paths: x-oasis-name-space: Common.Api /pets: get: parameters: - name: tags ... post: ... /pets/{id}: ... Run again, please note this time no --name-space argument, and the GET operation of the &quot;/pets&quot; path is no &quot;x-oasis-name-space&quot; either. mix oas . gen . plug -- file path / to / petstore - mini . yaml Generates Router and Plug modules from OAS * creating lib / common / api / router . ex * creating lib / common / api / pre_find_pet_by_id . ex * creating lib / common / api / find_pet_by_id . ex * creating lib / common / api / pre_add_pet . ex * creating lib / common / api / add_pet . ex * creating lib / common / api / pre_get_pets . ex * creating lib / common / api / get_pets . ex We can see all generated files are moved into the expected path, and all modules' name start with Common.Api . Summarize about the name space of generated module: The optional --name-space argument to the mix oas.gen.plug command line is in the highest priority to set the name space; We also can define &quot;x-oasis-name-space&quot; extension field in the specification document to make this archivable, please see here for details. HTTP request handler files in pairs The generated HTTP request handler files are named in pairs, one is pre_operation.ex , and another is operation.ex , the name beginning with pre_ file is in charge of converting and validating the parameters of each HTTP request definition, the content of this file will be updated according to the section of the document changes or Oasis upgrade in the future, so we CAN NOT write any business logic in this file; another file is only created in the first time of generation as long as this file does not exist, this is a common Plug module which is after the defined preprocessor by Plug 's pipeline, we need to fill in business logic in here. mix oas . gen . plug -- file path / to / petstore - mini . yaml Generates Router and Plug modules from OAS * creating lib / oasis / gen / router . ex * creating lib / oasis / gen / pre_find_pet_by_id . ex * creating lib / oasis / gen / find_pet_by_id . ex * creating lib / oasis / gen / pre_add_pet . ex * creating lib / oasis / gen / add_pet . ex * creating lib / oasis / gen / pre_get_pets . ex * creating lib / oasis / gen / get_pets . ex Integration After the above generation, let's integrate it, assume the generated router is Oasis.Gen.Router , we can use it in the Plug 's adapter like this: Plug.Adapters.Cowboy . child_spec ( scheme : :http , plug : Oasis.Gen.Router , options : [ port : port ] ) Or we can plug this router into the existence router module like this: defmodule MyExistenceRouter do use Plug.Router plug ( Oasis.Gen.Router ) plug ( :match ) plug ( :dispatch ) # other end Please note that the added line of plug(Oasis.Gen.Router) is before the line of plug(:match) .","ref":"readme.html#how-to-use","title":"Oasis - How to use","type":"extras"},{"doc":"The Specification contains XML object is not supported so far. Make document more clear. There are still some details maybe not implement(or bug) from the OAS, please create an issue or a PR for tracking, thanks in advanced :)","ref":"readme.html#todo","title":"Oasis - TODO","type":"extras"},{"doc":"The official OpenAPI Specification v3: Github | Official Web Site JSON Schema Reference","ref":"readme.html#reference","title":"Oasis - Reference","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fix test failed in OTP24 Add HMAC based authentication implement ( #8 ) Some fixing and enhancement ( #12 )","ref":"changelog.html#v0-5-0-2022-07-21","title":"Changelog - v0.5.0 (2022-07-21)","type":"extras"},{"doc":"Fix to make properly handle file uploads","ref":"changelog.html#v0-4-3-2021-05-13","title":"Changelog - v0.4.3 (2021-05-13)","type":"extras"},{"doc":"Add --force and --quiet options for mix oas.gen.plug","ref":"changelog.html#v0-4-2-2021-05-11","title":"Changelog - v0.4.2 (2021-05-11)","type":"extras"},{"doc":"Fix unexpected &quot;...&quot; string in generated pre_* module when a large number of parameters defined","ref":"changelog.html#v0-4-1-2021-04-29","title":"Changelog - v0.4.1 (2021-04-29)","type":"extras"},{"doc":"Improve errors handle and add a guide about it","ref":"changelog.html#v0-4-0-2021-04-14","title":"Changelog - v0.4.0 (2021-04-14)","type":"extras"},{"doc":"Fix incorrectly handle errors in generated plug module Simplify handle_errors/2 process in generated pre_* module","ref":"changelog.html#v0-3-1-2021-04-08","title":"Changelog - v0.3.1 (2021-04-08)","type":"extras"},{"doc":"Add conn.private.oasis_router Add a specification extensions guide Support Security Scheme Object with Bearer Authentication Fix the order to override x-oasis-name-space field","ref":"changelog.html#v0-3-0-2021-04-08","title":"Changelog - v0.3.0 (2021-04-08)","type":"extras"},{"doc":"Fix unexpected :body_schema in generated pre_* module","ref":"changelog.html#v0-2-1-2021-03-24","title":"Changelog - v0.2.1 (2021-03-24)","type":"extras"},{"doc":"Use Oasis.Controller","ref":"changelog.html#v0-2-0-2021-03-23","title":"Changelog - v0.2.0 (2021-03-23)","type":"extras"},{"doc":"Implement some parts of OpenAPI definition *Object in parse Implement a basic router and plugs pipeline process Add a mix task mix task oas.gen.plug to generate code 100% test coverage","ref":"changelog.html#v0-1-0-2021-03-17","title":"Changelog - v0.1.0 (2021-03-17)","type":"extras"},{"doc":"When we run mix oas.gen.plug mix task to generate the corresponding modules, we could see the following similar output (here are only for an example) ... * creating lib / oasis / gen / pre_list_pets . ex * creating lib / oasis / gen / list_pets . ex ... The &quot;pre_list_pets.ex&quot; and &quot;list_pets.ex&quot; files are in a pair, the former starts with &quot;pre_&quot; is in charge of the parse and validation to the request, the latter is after the former's pipeline process, the latter is in charge of the detailed business logic to write, and provide a handle_errors/2 function to process the errors: def handle_errors ( conn , %{ kind : _kind , reason : reason , stack : _stack } ) do message = Map . get ( reason , :message ) || &quot;Something went wrong&quot; send_resp ( conn , conn . status , message ) end The reason is an Oasis.BadRequestError exception with these errors: Oasis.BadRequestError.Invalid Oasis.BadRequestError.Required Oasis.BadRequestError.JsonSchemaValidationFailed Oasis.BadRequestError.InvalidToken We can use pattern math to process the potential errors like this: def handle_errors ( conn , %{ kind : _kind , reason : { error : % Oasis.BadRequestError.JsonSchemaValidationFailed { } = error } = reason , stack : _stack } ) do # inspect the `error` and `reason` to find more information about this error case. ... end def handle_errors ( conn , %{ kind : _kind , reason : { error : % Oasis.BadRequestError.InvalidToken { } = error } = reason , stack : _stack } ) do ... end def handle_errors ( conn , %{ kind : _kind , reason : reason , stack : _stack } ) do ... end","ref":"handle_errors.html","title":"Handle Errors","type":"extras"},{"doc":"Oasis be with the following specification extensions to accommodate some use cases in the defined YAML or JSON specification file.","ref":"specification_ext.html","title":"Specification Extensions","type":"extras"},{"doc":"&quot;x-oasis-name-space&quot; , optional, use this field to define the generated Elixir module's name space in the following objects, defaults to Oasis.Gen : Paths Object Operation Object Security Scheme Object Example In Paths Object Here, define this field in Paths Object as a global name space to the all generated modules meanwhile no other special definitions, in the below example there will use &quot;Hello.Petstore&quot; to the module naming prefix alias of the all generated modules. paths: /pets: get: ... /pets/{id}: get: ... delete: ... x-oasis-name-space: Hello.Petstore In Operation Object Here, define this field in Operation Object , it only affect to a operation related generated modules meanwhile no other special definitions, in the below example there will use &quot;Petstore.Api&quot; to the module naming prefix alias of the generated related modules to handler request of &quot;/pets&quot; in HTTP GET verb, other generated modules will use Oasis.Gen as the default. paths: /pets: get: x-oasis-name-space: Petstore.Api operationId: list pets ... /pets/{id}: get: ... delete: ... In Security Scheme Object Here, define this field in Security Scheme Object , it only affect to the generated bearer token module meanwhile no other special definitions, in the below example there will use &quot;Petstore.MyToken&quot; to the &quot;helloBearerAuth&quot; module (its full module name is &quot;Petstore.MyToken.HelloBearerAuth&quot;). paths: /pets: get: security: - helloBearerAuth: [] components: securitySchemes: helloBearerAuth: # arbitrary name for the security scheme scheme: bearer type: http x-oasis-name-space: Petstore.MyToken Summary &quot;x-oasis-name-space&quot; can be used at the same time for the above scenarios, but the defined in Security Scheme Object will override the defined in Operation Object for the generated bearer token module, the defined in Operation Object will override the defined in Paths Object for the corresponding operation related modules. We also can set a global name space when run mix oas.gen.plug with the --name-space argument, it applies to all generated modules and always override the defined from the specification file. Follow Elixir's module naming conventions, each dot(&quot;.&quot;) of module name will split the alias as a directory in lowercase to concat the full directory path, and also we do not validate the value of this field in a strict mode, so please follow the usual naming conventions as much as possible.","ref":"specification_ext.html#module-name-space","title":"Specification Extensions - Module Name Space","type":"extras"},{"doc":"&quot;x-oasis-router&quot; , optional, use this field to define the generated Elixir router module's alias in Paths Object , defaults to Router . Example When use an OpenAPI Specification to run mix oas.gen.plug , there will generate a router file and some corresponding operation handler modules files(in pair), the router file packages all defined HTTP router(s) to each hanlder(s), we can custom the module name of the router file by the &quot;x-oasis-router&quot; and &quot;x-oasis-name-space&quot; in the specification file, without other special name space defined, the following example defines the module full name space of the router module is &quot;Oasis.Gen.HelloRouter&quot;. paths: /pets: .. /pets/{id}: .. x-oasis-router: HelloRouter Summary We also can set a router name when run mix oas.gen.plug with the --router argument, it applies to the router module and always override the defined from the specification file. Follow Elixir's module naming conventions, each dot(&quot;.&quot;) of module name will split the alias as a directory in lowercase to concat the full directory path, and also we do not validate the value of this field in a strict mode, so please follow the usual naming conventions as much as possible.","ref":"specification_ext.html#router-module-alias","title":"Specification Extensions - Router Module Alias","type":"extras"},{"doc":"&quot;x-oasis-key-to-assigns&quot; , optional, after the verification of the token, the original data will be stored into this provided field (as an atom) of the conn.assigns for the next accessing, if not defined it, there won't do any process for the verified original data, please see Oasis.Plug.BearerAuth for details. Example Once the input token is verified, we can access the original data(decrypted from token) via conn.assigns.user_id in the next plug's pipeline. openapi: 3.1.0 components: securitySchemes: bearerAuth: # arbitrary name for the security scheme type: http scheme: bearer bearerFormat: JWT x-oasis-key-to-assigns: user_id paths: /something: get: security: - bearerAuth: []","ref":"specification_ext.html#save-data-from-bearer-token","title":"Specification Extensions - Save Data from Bearer Token","type":"extras"},{"doc":"&quot;x-oasis-signed-headers&quot; , requried when use HMAC authentication in security scheme object, this field represents which HTTP header(s) will be used into signature, please see HMAC-based authentication document for details.","ref":"specification_ext.html#signed-headers-for-hamc-authentication","title":"Specification Extensions - Signed Headers for HAMC Authentication","type":"extras"},{"doc":"","ref":"hmac_based_authentication.html","title":"HMAC-based Authentication","type":"extras"},{"doc":"STATEMENT : Currently there is no standard HMAC authentication definition in the OpenAPI v3.1.0 specification, we implement this function to add an hmac-&lt;algorithm&gt; as the corresponding scheme field to http type of the security scheme object in YAML/JSON specification, thanks for some public HMAC services or API design as references: Azure REST API Authentication HMAC AWS S3 sigv4 Authentication AWS general sigv4 Authentication example We need a mechanism based on the HTTP Authorization Header to authenticate access permissions to meet the following requirements: Make sure that the request is from a trusted client. Make sure that the some key HTTP headers are not tampered. (Optional) Make sure that the HTTP body is not tampered. (Optional) Make sure that the interval between the request send-time and the server received-time does not exceed a certain critical value. Oasis provides a complete set of scaffolding to easily build such a set of certification services.","ref":"hmac_based_authentication.html#backgroupd","title":"HMAC-based Authentication - Backgroupd","type":"extras"},{"doc":"Recommend HTTP request sent be transmitted over TLS/SSL on production. HTTP Authorization Header The client request must contains an Authorization HTTP header in this syntax: Authorization : HMAC - &lt; Algorithm &gt; Credential = &lt; value1 &gt; &amp; SignedHeaders = &lt; value2 &gt; &amp; Signature = &lt; value3 &gt; &lt;Algorithm&gt; , the algorithm name(in uppercase, e.g. SHA256 ) used to compute a Message Authentication Code of type hmac, supported algorithms please see here . Credential , the ID of the access key used to identify for server. SignedHeaders , the HTTP header names separated by semicolons( ; ), the values of these headers are required to signature the request in your defined order, the values of these HTTP headers should be properly provided in this request as well, do not use white spaces for the HTTP header name. Signature , a hash &lt;Algorithm&gt; with the String-to-Sign , and the value(aka Secret ) of the access key to the Credential , and then base64 encode the hashed result. About the String-to-Sign , please see as below: String-to-Sign = HTTP_METHOD + &quot;\\n&quot; + path_and_query_string + &quot;\\n&quot; + values_of_signed_headers Variable Description HTTP_METHOD The HTTP method of the request in uppercase, e.g. &quot;POST&quot; path_and_query_string The absolute URI with query string(if existed) of the request, e.g. &quot;/foo/bar?a=1&quot; values_of_signed_headers The values of all HTTP request headers listed in SignedHeaders , use semicolons( ; ) to separate the values in order of SignedHeaders . Example: String - to - Sign = &quot;POST&quot; + &quot; \\n &quot; + &quot;/new?version=1&quot; + &quot; \\n &quot; + &quot;2021-11-24 06:43:20.393420Z;foo.bar.host;{ \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; type \\&quot; :1}&quot; Let's take this pair of access key for example: Access Key ID Access Key Secret mykey_abc 123456789 Notice: the value of the access key secret should be only the client and server know it, and DO NOT use in plaintext in any transmission. The corresponding HTTP headers of the request are: Host : foo . bar . host Date : 2021 - 11 - 24 06 : 43 : 20.393420 Z Authorization : HMAC - SHA256 Credential = mykey_abc &amp; SignedHeaders = date ; host ; body &amp; Signature = oSBomxpJWcwlhVkif5LV80zecDLpts9Z13 + cth1NKV4 = Body : &quot;{ \\&quot; name \\&quot; : \\&quot; test \\&quot; , \\&quot; type \\&quot; :1}&quot; Refer the best practices, please try to keep the dynamic part of request into the signature. The way to concatenate a String-To-Sign is fixed, but there is a flexible customization to define your HTTP headers to sign via SignedHeaders field, properly keep the value(s) of the signed header(s) for the server side's verification, here are some pseudocode for example: x - oasis - content - sha256 : base64_encode ( SHA256 ( body ) ) x - oasis - content - md5 : base64_encode ( MD5 ( body ) )","ref":"hmac_based_authentication.html#protocol","title":"HMAC-based Authentication - Protocol","type":"extras"},{"doc":"1. Define schema in OpenAPI Specification # priv/oas/main.yaml openapi: &quot;3.1.0&quot; info: title: My API Title version: &quot;1.0&quot; paths: /test_hmac: post: # this API (/test_hmac) should be authenticated by HMAC-based Authentication security: - HMACAuth: [ ] requestBody: content: application/json: schema: type: object properties: a: type: string responses: &quot;200&quot;: description: OK /other: get: # and this API will not be authenticated responses: &quot;200&quot;: description: OK components: securitySchemes: HMACAuth: type: http # will use hmac hash sha256 algorithm scheme: hmac-sha256 # will verify host, request datetime and body hash x-oasis-signed-headers: host;x-oasis-date;x-oasis-body-sha256 The x-oasis-signed-headers field is a specification extension to define which HTTP header(s) will be used into signature. Some HTTP client libraries don't let you set the HTTP &quot;Date&quot; header, in this case, we can define an arbitrary naming(should be started with &quot;x-&quot;) to represent date related, for example, the above specification example defines an x-oasis-date HTTP header. In the above specification example, the x-oasis-body-sha256 is a customization HTTP header field, you can name it in a arbitrary naming(should be started with &quot;x-&quot;). 2. Generate Code # in the shell mix oas.gen.plug --file priv/oas/main.yaml Then you will get some similar generated files: # lib/oasis/gen/pre_post_test_hmac.ex defmodule Oasis.Gen.PrePostTestHMAC do # NOTICE: Please DO NOT write any business code in this module, since it will always be overridden when # run `mix oas.gen.plug` task command with the OpenAPI Specification file. use Oasis.Controller use Plug.ErrorHandler plug ( Plug.Parsers , parsers : [ :json ] , json_decoder : Jason , pass : [ &quot;*/*&quot; ] , body_reader : { Oasis.CacheRawBodyReader , :read_body , [ ] } ) plug ( Oasis.Plug.RequestValidator , body_schema : %{ &quot;content&quot; =&gt; %{ &quot;application/json&quot; =&gt; %{ &quot;schema&quot; =&gt; % ExJsonSchema.Schema.Root { schema : %{ &quot;properties&quot; =&gt; %{ &quot;a&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;string&quot; } } , &quot;type&quot; =&gt; &quot;object&quot; } } } } } ) plug ( Oasis.Plug.HMACAuth , signed_headers : &quot;host;x-oasis-date;x-oasis-body-sha256&quot; , algorithm : :sha256 , security : Oasis.Gen.HMACAuth ) def call ( conn , opts ) do conn |&gt; super ( opts ) |&gt; Oasis.Gen.PostTestHMACWithBody . call ( opts ) |&gt; halt ( ) end defdelegate handle_errors ( conn , error ) , to : Oasis.Gen.PostTestHMACWithBody end # lib/oasis/gen/hmac_auth.ex defmodule Oasis.Gen.HMACAuth do # NOTICE: This module is generated when run `mix oas.gen.plug` task command with the OpenAPI Specification file # in the first time, and then it WILL NOT be modified in the future generation command(s) once this file exists, # please write the crypto-related configuration to the bearer token in this module. @behaviour Oasis.HMACToken alias Oasis.HMACToken.Crypto @impl true def crypto_config ( _conn , _opts , _credential ) do # ... nil end @impl true def verify ( conn , token , opts ) do with { :ok , _ } &lt;- Oasis.HMACToken . verify ( conn , token , opts ) do { :ok , token } end end end 3. Implement your crypto_config/3 and verify/3 callbacks. # lib/oasis/gen/hmac_auth.ex defmodule Oasis.Gen.HMACAuth do # NOTICE: This module is generated when run `mix oas.gen.plug` task command with the OpenAPI Specification file # in the first time, and then it WILL NOT be modified in the future generation command(s) once this file exists, # please write the crypto-related configuration to the bearer token in this module. @behaviour Oasis.HMACToken alias Oasis.HMACToken.Crypto # in seconds @max_diff 60 @impl true def crypto_config ( _conn , _opts , _credential ) do # Here just an example # You should provide these sensitive information from config file or database % Crypto { credential : &quot;mykey_abc&quot; , secret : &quot;123456789&quot; } end @impl true def verify ( conn , token , opts ) do with { :ok , _ } &lt;- Oasis.HMACToken . verify ( conn , token , opts ) , { :ok , _ } &lt;- verify_date ( conn , token , opts ) , { :ok , _ } &lt;- verify_body ( conn , token , opts ) do { :ok , token } end defp verify_date ( conn , token , _opts ) do with { :ok , timestamp } &lt;- conn |&gt; get_header ( &quot;x-oasis-date&quot; ) |&gt; parse_header_date ( ) do timestamp_now = DateTime . utc_now ( ) |&gt; DateTime . to_unix ( ) if abs ( timestamp_now - timestamp ) &lt; @max_diff do { :ok , timestamp } else { :error , :expired } end end end defp verify_body ( conn , token , opts ) do algorithm = opts [ :algorithm ] raw_body = conn . assigns . raw_body crypto = crypto_config ( conn , opts , token . credential ) body_hmac = hmac ( algorithm , crypto . secret , raw_body ) body_hmac_header = get_header ( conn , &quot;x-oasis-body-sha256&quot; ) if body_hmac == body_hmac_header do { :ok , token } else { :error , :invalid_token } end end defp get_header ( conn , key ) do conn |&gt; Plug.Conn . get_req_header ( key ) |&gt; case do [ value ] -&gt; value _ -&gt; nil end end defp parse_header_date ( str ) when is_binary ( str ) do with { :ok , datetime } &lt;- Timex . parse ( str , &quot;%a, %d %b %Y %H:%M:%S GMT&quot; , :strftime ) , timestamp when is_integer ( timestamp ) &lt;- Timex . to_unix ( datetime ) do { :ok , timestamp } end end defp parse_header_date ( _otherwise ) , do : { :error , :expired } defp hmac ( subtype , secret , content ) do Base . encode64 ( :crypto . mac ( :hmac , subtype , secret , content ) ) end end","ref":"hmac_based_authentication.html#tutorial","title":"HMAC-based Authentication - Tutorial","type":"extras"}]